; d0=allow multiple card select
; Returns: d0=col, d1=sel count
select:
        movem.l d2-d7/a0-a4,-(a7)

        move.l d0,a4
        move.l selcol(pc),d6
        move.l #1,d7
        move.l #0,d4

selectloop:
        move.l d6,a3
        move.l d6,d0
        move.l d7,d1
        bsr getselpos
        bsr drawsel1
        bsr updatestatus

        bsr idle_loop
        and.l #$ffff,d0

        move.l d0,d5

        move.l d6,d0
        move.l d7,d1
        bsr getselpos
        bsr drawsel1

        cmp.l #KEY_LEFT,d5
        beq select_left
        cmp.l #KEY_RIGHT,d5
        beq select_right
        cmp.l #KEY_UP,d5
        beq select_up
        cmp.l #KEY_DOWN,d5
        beq select_down
        cmp.l #4096+KEY_UP,d5
        beq select_2nd_up
        cmp.l #4096+KEY_DOWN,d5
        beq select_2nd_down
        cmp.l #13,d5
        beq select_enter
        cmp.l #'0',d5
        beq select_0
        cmp.l #'.',d5
        beq select_period
        cmp.l #268,d5
        beq select_fn
        cmp.l #269,d5
        beq select_fn
        cmp.l #270,d5
        beq select_fn
        cmp.l #271,d5
        beq select_fn
        cmp.l #264,d5
        beq select_esc
        cmp.l #263,d5
        beq select_clear

        cmp.l #'1',d5
        blt selectloop
        cmp.l #'7',d5
        bgt selectloop

        sub.l #'0',d5
        move.l d5,d6
        move.l #1,d7
        bra selectnew

select_left:
        sub.l #1,d6
        move.l #1,d7
        cmp.l #1,d6
        bge selectnew
        move.l #13,d6
        bra selectnew

select_right:
        add.l #1,d6
        move.l #1,d7
        cmp.l #13,d6
        ble selectnew
        move.l #1,d6
        bra selectnew

select_up:
        cmp.l #0,a4
        beq selectloop
        cmp.l #8,d6
        bge selectloop
        move.l d6,d0
        bsr getstackup
        cmp.l d0,d7
        beq selectloop
        add.l #1,d7
        move.l d6,d0
        bsr getstackup
        move.l d0,d1
        move.l d6,d0
        bsr getstackvis
        cmp.l d0,d1
        beq selectloop
        cmp.l d0,d7
        blt selectloop
        cmp.l d1,d7
        beq selectloop
        move.l d6,d0
        move.l d7,d1
        bsr drawcol
        move.l #1,d4
        bra selectloop

select_down:
        cmp.l #0,a4
        beq selectloop
        cmp.l #1,d7
        beq selectloop
        sub.l #1,d7
        move.l d6,d0
        bsr getstackup
        move.l d0,d1
        move.l d6,d0
        bsr getstackvis
        cmp.l d0,d1
        beq selectloop
        move.l d7,d5
        add.l #1,d5
        cmp.l d0,d5
        blt selectloop
        cmp.l d1,d5
        beq selectloop
        move.l d6,d0
        move.l d7,d1
        bsr drawcol
        cmp.l d0,d7
        bge selectloop
        move.l #0,d4
        bra selectloop

select_2nd_up:
        cmp.l #0,a4
        beq selectloop
        cmp.l #8,d6
        bge selectloop
        move.l d6,d0
        bsr getstackup
        move.l d0,d7
        move.l d6,d0
        move.l d7,d1
        bsr drawcol
        move.l #1,d4
        cmp.l #1,d7
        bne selectloop
        move.l #0,d4
        bra selectloop

select_2nd_down:
        cmp.l #0,a4
        beq selectloop
        move.l #1,d7
        move.l d6,d0
        move.l d7,d1
        bsr drawcol
        move.l #0,d4
        bra selectloop

select_0:
        move.l #8,d6
        move.l #1,d7
        bra selectnew

select_period:
        move.l #9,d6
        move.l #1,d7
        bra selectnew

select_fn:
        sub.l #258,d5
        move.l d5,d6
        move.l #1,d7
        bra selectnew

selectnew:
        cmp.l #0,d4
        beq selectloop
        move.l #0,d4
        move.l a3,d0
        move.l #1,d1
        bsr drawcol
        bra selectloop

select_esc:
        move.l #0,d6
        bra select_enter

select_clear:
        move.l #-1,d6

select_enter:
        move.l d6,selcol
        move.l d7,selnum
        move.l d6,d0
        move.l d7,d1
        movem.l (a7)+,d2-d7/a0-a4
        rts

drawsel1:
        cmp.b #CALC_TI89,CALCULATOR
        beq drawsel1_89

        movem.l d0/a0-a1,-(a7)

        move.l gplane1,a0
        move.l gplane0,a1
        add.l d0,a0
        add.l d0,a1
        move.l d1,d0
        sub.l #1,d0
drawsel1loop:
        not.b (a0)+
        not.b (a0)+
        not.b (a0)+
        not.b (a1)+
        not.b (a1)+
        not.b (a1)+
        add.l #27,a0
        add.l #27,a1
;        cmp.l gplane1+3630,a0 ;LCD_MEM
;        bge drawsel1done
        dbra d0,drawsel1loop

drawsel1done:
        movem.l (a7)+,d0/a0-a1
        rts

drawsel2:
        cmp.b #CALC_TI89,CALCULATOR
        beq drawsel2_89

        movem.l d0-d2/a0,-(a7)

        move.l gplane0,a0
        move.l a0,d2
        add.l #3630,d2
        add.l d0,a0
        move.l d1,d0
        sub.l #1,d0
drawsel2loop:
        not.b (a0)+
        not.b (a0)+
        not.b (a0)+
        add.l #27,a0
        cmp.l d2,a0
        bge drawsel2done
        dbra d0,drawsel2loop

drawsel2done:
        movem.l (a7)+,d0-d2/a0
        rts

drawsel1_89:
        movem.l d0-d7/a0-a2,-(a7)

        divu.w #30,d0
        move.l d0,d2
        and.l #$ffff,d2
        mulu.w #30,d2
        lsr.l #8,d0
        lsr.l #8,d0
        sub.l #1,d0
        lsr.l #2,d0
        mulu.w #22,d0
        add.l #2,d0
        move.l d0,d89col

        move.l gplane1,a0
        move.l gplane0,a1
        add.l d2,a0
        add.l d2,a1
        bsr addcola0
        bsr addcola1
        move.l d1,d0
        sub.l #6,d0
        move.l gplane1,a2 ;LCD_MEM
        add.l #STATUS_LINE_OFS,a2
drawsel1loop89:
        move.l #$00fffff0,d4
        lsl.l d6,d4
        eor.b d4,3(a0)
        lsr.l #8,d4
        eor.b d4,2(a0)
        lsr.l #8,d4
        eor.b d4,1(a0)
        lsr.l #8,d4
        eor.b d4,(a0)
        move.l #$00fffff0,d4
        lsl.l d6,d4
        eor.b d4,3(a1)
        lsr.l #8,d4
        eor.b d4,2(a1)
        lsr.l #8,d4
        eor.b d4,1(a1)
        lsr.l #8,d4
        eor.b d4,(a1)
        add.l #30,a0
        add.l #30,a1
        cmp.l a2,a0
        bge drawsel1done89
        dbra d0,drawsel1loop89

drawsel1done89:
        movem.l (a7)+,d0-d7/a0-a2
        rts

drawsel2_89:
        movem.l d0-d7/a0-a1,-(a7)

        divu.w #30,d0
        move.l d0,d2
        and.l #$ffff,d2
        mulu.w #30,d2
        lsr.l #8,d0
        lsr.l #8,d0
        sub.l #1,d0
        lsr.l #2,d0
        mulu.w #22,d0
        add.l #2,d0
        move.l d0,d89col

        move.l gplane0,a0
        move.l a0,a1
        add.l #STATUS_LINE_OFS,a1
        add.l d2,a0
        bsr addcola0
        move.l d1,d0
        sub.l #6,d0
drawsel2loop89:
        move.l #$00fffff0,d4
        lsl.l d6,d4
        eor.b d4,3(a0)
        lsr.l #8,d4
        eor.b d4,2(a0)
        lsr.l #8,d4
        eor.b d4,1(a0)
        lsr.l #8,d4
        eor.b d4,(a0)
        add.l #30,a0
        cmp.l a1,a0
        bge drawsel2done89
        dbra d0,drawsel2loop89

drawsel2done89:
        movem.l (a7)+,d0-d7/a0-a1
        rts
