;;;;;;;;;;;;;;;;;;;;;;
;  Solitare v2.2 !
;  Ported to ROMs v2.0x and HW2 compatibility by Flavien Racine
;   <FlashZ@netcourrier.com>
;   http://www.flashzed.org/
;;;;;;;;;;;;;;;;;;;;;;

        include "tios.h"
        include "gray4lib.h"
        include "hufflib.h"

        xdef _main
        xdef _comment
        xdef _ti92plus
;        xdef _ti92
        xdef _ti89

        EXTRA_RAM_TABLE
        EXTRA_RAM_ADDR 0000,DUMMY_EXTRA_RAM_ADDR_1,0,0
        EXTRA_RAM_ADDR 0001,DUMMY_EXTRA_RAM_ADDR_2,0,0
        EXTRA_RAM_ADDR 0002,STAT_NAME_X,58,98
        EXTRA_RAM_ADDR 0003,STAT_NAME_Y,39,43
        EXTRA_RAM_ADDR 0004,STAT_FONT,0,1
        EXTRA_RAM_ADDR 0005,STAT_HANDS_X,16,32
        EXTRA_RAM_ADDR 0006,STAT_HANDS_Y,45,50
        EXTRA_RAM_ADDR 0007,STAT_WINS_X,16,32
        EXTRA_RAM_ADDR 0008,STAT_WINS_Y,51,58
        EXTRA_RAM_ADDR 0009,STAT_AVGSCORE_X,87,124
        EXTRA_RAM_ADDR 000A,STAT_AVGSCORE_Y,45,50
        EXTRA_RAM_ADDR 000B,STAT_WINPCT_X,87,124
        EXTRA_RAM_ADDR 000C,STAT_WINPCT_Y,51,58
        EXTRA_RAM_ADDR 000D,STAT_STREAK_X,12,26
        EXTRA_RAM_ADDR 000E,STAT_STREAK_Y,57,66
        EXTRA_RAM_ADDR 000F,AVG_CHAR_WIDTH,4,6
        EXTRA_RAM_ADDR 0010,STAT_LONG_X,148,214
        EXTRA_RAM_ADDR 0011,STAT_LONG_Y,57,66
        EXTRA_RAM_ADDR 0012,AVG_CHAR_WIDTH_DIV_2,2,3
        EXTRA_RAM_ADDR 0013,STAT_FAST_X,85,120
        EXTRA_RAM_ADDR 0014,STAT_FAST_Y,63,74
        EXTRA_RAM_ADDR 0015,STAT_TIME_X,86,120
        EXTRA_RAM_ADDR 0016,STAT_TIME_Y,69,82
        EXTRA_RAM_ADDR 0017,STAT_HIGH_NAME_X,42,63
        EXTRA_RAM_ADDR 0018,STAT_HIGH_SCORE_X,106,159
        EXTRA_RAM_ADDR 0019,STAT_HIGH1_Y,75,95
        EXTRA_RAM_ADDR 001A,STAT_HIGH2_Y,81,103
        EXTRA_RAM_ADDR 001B,STAT_HIGH3_Y,87,111
        EXTRA_RAM_ADDR 001C,LCD_MID_Y,50,64
        EXTRA_RAM_ADDR 001D,LCD_MID_X,80,120
        EXTRA_RAM_ADDR 001E,LCD_MID_X_BYTES,10,15
        EXTRA_RAM_ADDR 001F,STATUS_LINE_OFS,2790,3630
        EXTRA_RAM_ADDR 0020,STATUS_Y,95,123
        EXTRA_RAM_ADDR 0021,STATUS_SCORE_X,0,70
        EXTRA_RAM_ADDR 0022,STATUS_HIGH_X,50,128
        EXTRA_RAM_ADDR 0023,ABOUT_X,16,38
        EXTRA_RAM_ADDR 0024,ABOUT1_Y,41,45
        EXTRA_RAM_ADDR 0025,ABOUT2_Y,47,53
        EXTRA_RAM_ADDR 0026,ABOUT3_Y,55,63
        EXTRA_RAM_ADDR 0027,ABOUT4_Y,61,69
        EXTRA_RAM_ADDR 0028,ABOUT5_Y,69,79
        EXTRA_RAM_ADDR 0029,ABOUT6_Y,75,87
        EXTRA_RAM_ADDR 002A,ABOUT7_Y,81,95
        EXTRA_RAM_ADDR 002B,STACK_START_OFS,871,1021
        EXTRA_RAM_ADDR 002C,STACK_CLEAR_ROWS,64,87
        EXTRA_RAM_ADDR 002D,STACK_MAX_OFS,2490,3330
        EXTRA_RAM_ADDR 002E,WINTEXT1_X,52,72
        EXTRA_RAM_ADDR 002F,WINTEXT2_X,35,45
        EXTRA_RAM_ADDR 0030,WINTEXT3_X,41,48
        EXTRA_RAM_ADDR 0031,FASTTEXT1_X,42,57
        EXTRA_RAM_ADDR 0032,FASTTEXT2_X,44,57
        EXTRA_RAM_ADDR 0033,FASTLINE1_Y,50,62
        EXTRA_RAM_ADDR 0034,FASTLINE2_Y,56,70
        EXTRA_RAM_ADDR 0035,FASTLINE3_Y,62,78
        EXTRA_RAM_ADDR 0036,FASTLINE4_Y,68,86
        EXTRA_RAM_ADDR 0037,HISCORE1_X,29,69
        EXTRA_RAM_ADDR 0038,HISCORE1_Y,50,61
        EXTRA_RAM_ADDR 0039,HISCORE2_X,32,72
        EXTRA_RAM_ADDR 003A,HISCORE2_Y,63,74
        EXTRA_RAM_ADDR 003B,HISCORE3_X,44,84
        EXTRA_RAM_ADDR 003C,HISCORE3_Y,71,82
        EXTRA_RAM_ADDR 003D,HISCORE_Y_CHG,6,8
        EXTRA_RAM_ADDR 003E,VEGAS_HIGH_NAME_X,40,60
        EXTRA_RAM_ADDR 003F,VEGAS_HIGH_SCORE_X,100,150
        EXTRA_RAM_ADDR 0040,VEGAS_HANDS_X,83,120
        EXTRA_RAM_ADDR 0041,VEGAS_WINS_X,84,120
        EXTRA_RAM_ADDR 0042,VEGAS_WINPCT_X,84,120

romlib[sprintf] equ tios::sprintf
gplane0 equ gray4lib::plane0
gplane1 equ gray4lib::plane1

_main:
        bsr start_timer
        jsr gray4lib::on

        tst.l vegas
        beq gamenotvegas
        move.l #vegasstats,stats
        bra statsptrend
gamenotvegas:
        cmp.b #3,drawcards
        beq gamenotdraw1
        move.l #draw1stats,stats
        bra statsptrend
gamenotdraw1:
        move.l #draw3stats,stats
statsptrend:

        cmp.l #1,ingame
        beq playgame

startover:

        bsr drawtitle
        bsr drawstats

        bsr idle_loop
        cmp.w #264,d0
        beq quit

        move.l #0,d0
        bsr domainmenu
        cmp.l #-1,d0
        beq startover

        bsr init

playgame:
        bsr clrscr
        bsr redraw

        move.l #8,selcol

mainloop:
        move.l #1,d0
        bsr select
        cmp.l #0,d0
        beq quit
        cmp.l #-1,d0
        beq endgame
        move.l d0,fromcol
        move.l d1,fromnum
        cmp.l #8,d0
        beq movenow
        bsr isempty
        cmp.l #0,d0
        bne mainloop
        move.l fromcol(pc),d0
        bsr getselpos
        bsr drawsel2

        move.l #0,d0
        bsr select
        cmp.l #0,d0
        beq quit
        cmp.l #-1,d0
        beq endgame
        move.l d0,tocol
        move.l fromcol(pc),d0
        move.l fromnum(pc),d1
        bsr getselpos
        bsr drawsel2
        move.l fromcol(pc),d0
        move.l #1,d1
        bsr drawcol

movenow:
        bsr domove
        bsr updatestatus

        cmp.l #0,autoplay
        beq mainloop

        cmp.l #0,autoplay+4
        bne mainloop

        move.l #1,d1
apcloop:
        move.l d1,d0
        bsr getstackdn
        cmp.l #0,d0
        bne mainloop
        add.l #1,d1
        cmp.l #7,d1
        ble apcloop

        move.l #0,d1
apcloop2:
        move.l d1,d0
        bsr getace
        cmp.l #52,d0
        bge mainloop
        add.l #1,d1
        cmp.l #4,d1
        blt apcloop2

        cmp.l #0,decklen
        bne mainloop

        move.l #1,d0
        move.l #0,d1
aploop:
        bsr setstackup
        bsr setstacklen
        add.l #1,d0
        cmp.l #7,d0
        ble aploop

        move.l #0,d2
aploop2:
        move.l d2,d0
        bsr getace
        bsr getsuitnum
        mulu.w #13,d1
        add.l #12,d1
        move.l d2,d0
        bsr putace
        add.l #1,d2
        cmp.l #4,d2
        blt aploop2

        bsr redraw

        move.l goal(pc),d0
        move.l d0,score
        bsr drawstatus

        move.l #1,autoplay+4

        bra mainloop

quit:
        move.l gplane0,a6
        jsr gray4lib::off
        bsr end_timer

        rts

endgame:
        move.l #0,ingame

        bsr updatetotaltime

        cmp.l #0,vegas
        bne endvegasgame
        move.l score(pc),d0
        move.l goal(pc),d1
        cmp.l d0,d1
        beq didit

        bsr updatestats

        move.l score(pc),d0
        move.l stats(pc),a0
        cmp.l HISCORE1(a0),d0
        bgt dohigh1
        cmp.l HISCORE1+4(a0),d0
        bgt dohigh2
        cmp.l HISCORE1+8(a0),d0
        bgt dohigh3
        bra startover

endvegasgame:
        bsr updatevegasstats

vegasmenuloop:
        move.l score(pc),d0
        move.w d0,-(a7)
        move.l #tempstr+32,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7

        move.l #vegasmenu,a0
        move.l #1,d0
        bsr domenu

        cmp.l #-1,d0
        beq vegasmenuloop

        cmp.l #0,d0
        beq vegasstartover

        move.l #3,ingame
        bsr init
        bra playgame

vegasstartover:
        move.l score(pc),d0
        move.l stats(pc),a0
        cmp.l HISCORE1(a0),d0
        bgt dohigh1
        cmp.l HISCORE1+4(a0),d0
        bgt dohigh2
        cmp.l HISCORE1+8(a0),d0
        bgt dohigh3
        bra startover

didit:
        bsr updatefastwin
        bsr drawtitle

        move.w #STAT_FONT,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7

        tst.w fastestwin
        beq drawwintextonly

        move.w #0,-(a7)
        move.l #str_wintext1,-(a7)
        move.w #FASTLINE1_Y,-(a7)
        move.w #WINTEXT1_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.w #0,-(a7)
        move.l #str_fasttext1,-(a7)
        move.w #FASTLINE2_Y,-(a7)
        move.w #FASTTEXT1_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.w #0,-(a7)
        move.l #str_fasttext2,-(a7)
        move.w #FASTLINE3_Y,-(a7)
        move.w #FASTTEXT2_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.w #FASTLINE4_Y,d0

        bra drawwintext
drawwintextonly:
        move.w #0,-(a7)
        move.l #str_wintext1,-(a7)
        move.w #FASTLINE2_Y,-(a7)
        move.w #WINTEXT1_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.w #FASTLINE3_Y,d0

drawwintext:
        move.w d0,-(a7)
        move.w #0,-(a7)
        move.l #str_wintext2,-(a7)
        move.w d0,-(a7)
        move.w #WINTEXT2_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.w (a7)+,d0

        move.w #0,-(a7)
        move.l #str_wintext3,-(a7)
        add.w #HISCORE_Y_CHG,d0
        move.w d0,-(a7)
        move.w #WINTEXT3_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        bsr idle_loop

        move.l #2,ingame
        add.l #52,goal
        bsr init
        bra playgame


init:
        movem.l d0-d7/a0-a2,-(a7)
        move.l #51,d0
        move.l #0,d1
initloop:
        move.l #deck,a0
        add.l d1,a0
        move.b d1,(a0)
        add.l #1,d1
        dbra d0,initloop
        move.l #512,d1
shuffleloop:
        move.l #52,d0
        jsr util::random
        and.l #$ffff,d0
        move.l d0,d2
        move.l #52,d0
        jsr util::random
        and.l #$ffff,d0
        move.l d0,d3
        move.l #deck,a0
        move.l a0,a1
        add.l d2,a0
        add.l d3,a1
        move.b (a0),d4
        move.b (a1),(a0)
        move.b d4,(a1)
        dbra d1,shuffleloop
        move.b #52,decklen
        move.b #0,deckptr
        move.l #deck,a0
        add.l #51,a0
        move.l #0,d0
dealloop1:
        move.l #stack,a1
        move.l d0,d1
        mulu.w #20,d1
        add.l d1,a1
        move.l #0,d1
dealloop2:
        move.b (a0),(a1)
        sub.l #1,a0
        add.l #1,a1
        sub.b #1,decklen
        add.l #1,d1
        cmp.l d0,d1
        ble dealloop2
        move.l #stack+154,a1
        add.l d0,a1
        move.b d0,(a1)
        add.b #1,(a1)
        move.l #stack+147,a1
        add.l d0,a1
        move.b d0,(a1)
        move.l #stack+140,a1
        add.l d0,a1
        move.b #1,(a1)
        add.l #1,d0
        cmp.l #7,d0
        blt dealloop1
        move.l #deck-4,a0
        move.b #53,(a0)+
        move.b #53,(a0)+
        move.b #53,(a0)+
        move.b #53,(a0)
        move.l score(pc),d1
        cmp.l #2,ingame
        beq initend
        move.l #52,goal
        move.l #0,d1
        cmp.l #0,vegas
        beq initend
        move.l #-52,d1
        move.l #208,goal
        cmp.l #3,ingame
        bne initend
        move.l score(pc),d1
        sub.l #52,d1
        move.l d1,d0
        add.l #260,d0
        move.l d0,goal
        bra initend
initend:
        move.l d1,score
        move.l #0,throughdeck
        move.l #0,decknomore
        move.l #0,autoplay+4
        move.l #1,ingame
        bsr reset_timer
        movem.l (a7)+,d0-d7/a0-a2
        rts

redraw:
        movem.l d0-d1,-(a7)
        move.l #1,d0
        move.l #1,d1
redrawloop:
        bsr drawcol
        add.l #1,d0
        cmp.l #13,d0
        ble redrawloop
        bsr drawstatus
        movem.l (a7)+,d0-d1
        rts

clrscr:
        movem.l d0/a0-a1,-(a7)

        move.l gplane1,a0
        move.l gplane0,a1
        move.l #959,d0
clrscrloop:
        clr.l (a0)+
        clr.l (a1)+
        dbra d0,clrscrloop

        movem.l (a7)+,d0/a0-a1
        rts

; Includes
        include "util.asm"
        include "title.asm"
        include "cards.asm"
        include "drawcard.asm"
        include "dcard89.asm"
        include "drawcol.asm"
        include "select.asm"
        include "move.asm"
        include "status.asm"
        include "menu.asm"
        include "mainmenu.asm"
        include "stats.asm"
        include "hiscore.asm"
        include "timer.asm"

stack ds.b 20*7
        ds.b 7
        ds.b 7
        ds.b 7
        ds.b 7
        ds.b 4

deck ds.b 52
decklen dc.b 0
deckptr dc.b 0

ingame dc.l 0

score dc.l 0
goal dc.l 0

selcol dc.l 0
selnum dc.l 0

fromcol dc.l 0
fromnum dc.l 0
tocol dc.l 0

workareasize dc.l 0
workarea ds.b 14

throughdeck dc.l 0
decknomore dc.l 0

HINAME1 EQU 3
HISCORE1 EQU 48
HANDS EQU 60
MORESTATS EQU 86
GAMES EQU 90
AVGSCORE EQU 94


draw1stats dc.b "1) ","Unknown",0,0,0,0,0,0
           dc.b "2) ","Unknown",0,0,0,0,0,0
           dc.b "3) ","Unknown",0,0,0,0,0,0
           dc.l 0,0,0
           dc.l 0,0,0
           dc.b "Draw 1 Stats",0,0
           dc.l 1
           dc.l 0,0,0,0,0

draw3stats dc.b "1) ","Unknown",0,0,0,0,0,0
           dc.b "2) ","Unknown",0,0,0,0,0,0
           dc.b "3) ","Unknown",0,0,0,0,0,0
           dc.l 0,0,0
           dc.l 0,0,0
           dc.b "Draw 3 Stats",0,0
           dc.l 1
           dc.l 0,0,0,0,0

vegasstats dc.b "1) ","Unknown",0,0,0,0,0,0
           dc.b "2) ","Unknown",0,0,0,0,0,0
           dc.b "3) ","Unknown",0,0,0,0,0,0
           dc.l 0,0,0
           dc.l 0,0,0
           dc.b "Vegas Stats",0,0,0
           dc.l 0

fastestwin dc.w 0
fastwin_sec dc.w 59
fastwin_sec1 dc.w 9
fastwin_sec10 dc.w 5
fastwin_min dc.w 9

totaltime_sec dc.w 0
totaltime_min dc.w 0
totaltime_hr dc.w 0

cur_sec dc.w 0
cur_sec1 dc.w 0
cur_sec10 dc.w 0
cur_min dc.w 0
cur_min1 dc.w 0
cur_min10 dc.w 0

stats dc.l draw3stats

allowfromace dc.l 1
vegas dc.l 0
autoplay dc.l 1
        dc.l 0

; Byte Variables
drawcards dc.b 3

; Menus
mainmenu dc.l 3,10,str_solitare,mainmenu_item1,mainmenu_item1+12
         dc.l mainmenu_item1+18
optionsmenu dc.l 4,18,mainmenu_item1+18,optionsmenu_item1,
            dc.l optionsmenu_item1+18,optionsmenu_item1+41
            dc.l optionsmenu_item1+64
vegasmenu dc.l 2,9,tempstr,tempstr+46,tempstr+50

; Strings
tempstr dc.l 0,0,0,0,0,0,0,0
        dc.b "End with $%d?",0
        dc.b "Yes",0
        dc.b "No",0
mainmenu_item1 dc.b "Play a game",0
               dc.b "About",0
               dc.b "Options",0
optionsmenu_item1 dc.b "Draw          = 3",0
                  dc.b "Scoring       = Normal",0
                  dc.b "Take from ace = OK",0,0,0,0,0
                  dc.b "Autoplay      = On",0,0
strx_score dc.b "Score: %d",0
        dc.b "Money: "
strx_money89 dc.b "$%d",0
        dc.b "You now have 1st!",0,0,0,0,0,0,0,0,0
        dc.b "You now have 2nd!",0,0,0,0,0,0,0,0,0,0
        dc.b "You now have 3rd!",0,0,0,0,0,0,0,0,0
        dc.b "Enter your name:",0
strx_hiscore dc.b "Hi Score: %d (%s)",0
        dc.b "Hi Score: $%d (%s)",0
        dc.b "New High Score!",0
strx_hands dc.b "Hands:  %d",0
strx_wins dc.b "Wins:   %d",0
;        dc.b "Losses: %d",0
;        dc.b "Games:     %3d",0
strx_avgscore dc.b "Avg Score: %3d",0
strx_winpct dc.b "Winning %%: %3d%%",0
strx_streak dc.b "Streak: %d%s",0
strx_streaktype dc.b " loss",0,0,0," losses",0
strx_streaklong dc.b "Longest: %d",0
strx_fastwin dc.b "Fastest Win: %d:%d%d",0
strx_totaltime dc.b "Total Playing Time: %d hr %d min",0
strx_num dc.b "%3d",0
        dc.b "Hands:  %3d",0
        dc.b "Wins:   %3d",0
        dc.b "Losses: %3d",0
        dc.b "$%4d",0
str_fasttext1 dc.b "You have recorded the",0
str_fasttext2 dc.b "fastest winning hand!",0
str_solitare dc.b "Solitaire",0
_comment     dc.b "Rusty's Ultimate Solitaire",0
str_wintext1 dc.b "Congratulations!",0
str_wintext2 dc.b "Your score will now carry",0
str_wintext3 dc.b "over to the next hand...",0
        dc.b "Version 2.2",0,0,0,0,0,0,0,0,0,0
        dc.b "Written by Rusty Wagner",0
        dc.b "Send questions, comments, or bugs to river@gte.net",0
        dc.b "Please see the documentation",0
        dc.b "for information about how",0
        dc.b "to play this game.",0
timestr dc.b "     %d:%d%d",0
timestr2 dc.b "   %d%d:%d%d",0
email89 dc.b "E-mail questions to river@gte.net",0

        cnop 0,4
title89bits:
        incbin "title89.huf"

        bss
title89data ds.w 720

        end
